using CompScienceMeshes
using BEAST

Γ = readmesh(joinpath(dirname(pathof(BEAST)),"../examples/sphere2.in"))
# Γ = meshsphere(radius=1.0, h=0.1)
# Γ = CompScienceMeshes.meshmobius(h=0.035)
X = raviartthomas(Γ)

κ, η = 1.0, 1.0
t = Maxwell3D.singlelayer(wavenumber=κ)
E = Maxwell3D.planewave(direction=ẑ, polarization=x̂, wavenumber=κ)
# E = -η/(im*κ)*BEAST.CurlCurlGreen(κ, ẑ, point(2,0,0))
e = (n × E) × n

@hilbertspace j
@hilbertspace k
efie = @discretise t[k,j]==e[k]  j∈X k∈X
u, ch = BEAST.gmres_ch(efie; restart=1500)

include("utils/postproc.jl")
include("utils/plotresults.jl")

qsg(g) = BEAST.DoubleNumWiltonSauterQStrat(6, 7, 6, 7, g, g, g, g)
A1 = assemble(t,X,X;quadstrat=qsg(5))
A2 = assemble(t,X,X;quadstrat=qsg(10))
A2 = assemble(t,X,X;quadstrat=qsg(20))
val, pos = findmax(abs.(A2-A3))

import Plots
Plots.plotly()
Plots.plot(abs.(A2[537,:]))
Plots.scatter!(abs.(A3[537,:]))